Subject: bug#64122: 30.0.50; The new Eglot mode line UI show too many 100% when input characters

From: João Távora <[email-masked]>
Date: Fri, 2 Feb 2024 09:25:22 +0000

On Fri, Feb 2, 2024 at 7:34 AM Stefan Kangas <[email-masked]> wrote:
>
> Eason Huang <[email-masked]> writes:
>
> > Eason Huang <[email-masked]> writes:
> >
> >> Hi João,
> >>
> >> I found that Eglot mode line UI will show many 100% when using with
> >> python-lsp-server, such as [Eglot:100%/100%/100%/100%/100%].
> >>
> >> Is it possible to disable it and only show the [Eglot:ProjecName] in
> >> mode-line?
> >>
> >>
> >> steps to reproduce:
> >>
> >> 1. install python-lsp-server:
> >> https://github.com/python-lsp/python-lsp-server
> >> `pip install python-lsp-server`
> >> 2. Start Emacs with `emacs -Q`
> >> 3. open a python file with `C-x C-f ~/test.py`
> >> 4. start Eglot with `M-x eglot`, choose `pylsp` as the server.
> >> 5. Input some blank line the test.py buffer and you will see the issue.
> >> In the mode line, there are always showing many 100%, such as
> >> [Eglot:100%/100%/100%/100%/100%]
> >>
> >> This issue also happen when using eglot on Java with Eclipse JDT
> >> Language Server[https://github.com/eclipse/eclipse.jdt.ls]
> >>
> >> This issue make the servers unusable on Eglot, because it will
> >> influence the performance, and I can feel the delay when input characters.
> >>
> >
> >
> > `(setopt eglot-report-progress nil)` can fix this issue.
>
> João, any comments here?

* There might be display bug, which would be down to not calling
  force-mode-line-update often enough.  I also see the indicators
  linger, sometimes and it's annoying, but goes away soon enough

  In any case this "there are always showing many 100%" is
  is maybe coloured by some creativity of interpretation :-)  IME they
  go away after some time.

* It might just be the intended behaviour.  Each of those percentage
  indications is a separate "progress operation" that the server
  wants to report on.  We could cap the number of such progress operations
  displayed to some upper limit.

* As to the performance problem, I doubt it is related to the display
  logic itself, and is more likely due the usually frenetic JSON
  communication that happens during bootup.  Up until relatively
  recently, this slowdown wasn't even due to the communication
  itself, but due to the logging of such communication.  And _that_
  problem is mostly probably gone.

So to summarize:

* For the performance, we would need measurements, i.e. profiler-start,
  profiler-stop, profiler-report for the "slowdown case" and the
  "fix this issue" case.

* For the minor display bug, I'll see if I can make the 100% go away
  quicker.

* I think the "cap number of progress operations" feature I floated
  would be most likely bloat, since this is relatively minor, so that's
  for the next maintainer to decide ;-)

João